/*****************************************************
Chip type               : ATtiny13A
AVR Core Clock frequency: 9,600000 MHz
*****************************************************/

#include <tiny13a.h>

#define ADC_itn 8



bit LoBat=0;
unsigned char c=0;
unsigned char tmr0, tmr1, ADC1;

#define s_step 188
flash unsigned char s_table [s_step/2]=
{0,4,8,12,16,21,25,29,33,37,41,46,50,54,58,62,66,70,74,78,82,
86,90,94,98,102,106,109,113,117,121,124,128,132,135,139,142,146,149,152,156,159,
162,165,169,172,175,178,181,184,186,189,192,195,197,200,202,205,207,210,212,214,216,
218,220,222,224,226,228,230,231,233,234,236,237,238,240,241,242,243,244,245,246,247,
247,248,249,249,249,250,250,250,250,250};

void t0_cfg()
{
 TCCR0A=0;
 TCCR0A=0; TCCR0A|=1<<COM0A1|1<<COM0B1|1<<WGM00;
 TCCR0B=0;TCCR0B|=1<<CS00;
 TIMSK0|=1<<OCIE0A;
}
void ports_cfg()
{
 PORTB=0b11101000;
 DDRB =0b11111011;
}
void adc_cfg()
{
 ADMUX|=1<<REFS0|1<<ADLAR|1;
 ADCSRA|=1<<ADEN|1<<ADSC|7;
}
void adc_scan()
{
 static unsigned char ADC1_tmp [ADC_itn]; 
 unsigned int dtmp=0;
 unsigned char i = 0;
 static bit a1f=0;
 
 if (!a1f) {for(i=0;i<ADC_itn-1;i++){ADC1_tmp[i]=200;a1f=1;}}

if(!ADCSRA.ADSC)
{ 
  for (i=0; i<(ADC_itn-1); i++ ) {ADC1_tmp [i] = ADC1_tmp [i+1];}
  ADC1_tmp [(ADC_itn-1)] = ADCH;
  for (i=0; i<(ADC_itn); i++ ) { dtmp += ADC1_tmp [i];}
  ADC1 = dtmp/ADC_itn; 
  ADCSRA |= 1<<ADSC;
}
}
void bat_detect()
{
 if(ADC1>170){tmr1=250;}   
 else if (ADC1<50){LoBat=1;tmr0=250;}
 if(!tmr1) {LoBat=1;tmr0=250;} 
 if(!tmr0) {LoBat=0;}
}

interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
 static bit dir;
 
 if(!c)                                          
 {
 dir=1;c=1;
 PORTB^=0b00011000;
 if(tmr0)tmr0--;    
 if(tmr1)tmr1--;
 }
 else if((dir)&&(c<s_step/2-1))
 {OCR0A=s_table[c]; if(s_table[c]>3){OCR0B=s_table[c]-4;}else{OCR0B=0;} c++;}
 else {c--; OCR0A=s_table[c]; if(s_table[c]>3){OCR0B=s_table[c]-4;}else{OCR0B=0;} dir=0;} 
 
 #asm("wdr")  
}

void main(void)
{
ports_cfg();
t0_cfg();
adc_cfg();



// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
// Watchdog Timer Prescaler: OSC/2k
#pragma optsize-
WDTCR=0x18;
WDTCR=0x08;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei")

while (1)
      {  
       static bit trg=0; 
          
       adc_scan(); 
       bat_detect();
       if(LoBat){TCCR0A=1<<WGM00;trg=1;}
       else if(trg) {TCCR0A=1<<COM0A1|1<<COM0B1|1<<WGM00;trg=0;c=1;}        
      }
}
